// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles

(function (modules, entry, mainEntry, parcelRequireName, globalName) {
  /* eslint-disable no-undef */
  var globalObject =
    typeof globalThis !== 'undefined'
      ? globalThis
      : typeof self !== 'undefined'
      ? self
      : typeof window !== 'undefined'
      ? window
      : typeof global !== 'undefined'
      ? global
      : {};
  /* eslint-enable no-undef */

  // Save the require from previous bundle to this closure if any
  var previousRequire =
    typeof globalObject[parcelRequireName] === 'function' &&
    globalObject[parcelRequireName];

  var cache = previousRequire.cache || {};
  // Do not use `require` to prevent Webpack from trying to bundle this call
  var nodeRequire =
    typeof module !== 'undefined' &&
    typeof module.require === 'function' &&
    module.require.bind(module);

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire =
          typeof globalObject[parcelRequireName] === 'function' &&
          globalObject[parcelRequireName];
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error("Cannot find module '" + name + "'");
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = (cache[name] = new newRequire.Module(name));

      modules[name][0].call(
        module.exports,
        localRequire,
        module,
        module.exports,
        this
      );
    }

    return cache[name].exports;

    function localRequire(x) {
      var res = localRequire.resolve(x);
      return res === false ? {} : newRequire(res);
    }

    function resolve(x) {
      var id = modules[name][1][x];
      return id != null ? id : x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [
      function (require, module) {
        module.exports = exports;
      },
      {},
    ];
  };

  Object.defineProperty(newRequire, 'root', {
    get: function () {
      return globalObject[parcelRequireName];
    },
  });

  globalObject[parcelRequireName] = newRequire;

  for (var i = 0; i < entry.length; i++) {
    newRequire(entry[i]);
  }

  if (mainEntry) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(mainEntry);

    // CommonJS
    if (typeof exports === 'object' && typeof module !== 'undefined') {
      module.exports = mainExports;

      // RequireJS
    } else if (typeof define === 'function' && define.amd) {
      define(function () {
        return mainExports;
      });

      // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }
})({"dq1FX":[function(require,module,exports) {
"use strict";
function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") _typeof = function _typeof(obj) {
        return typeof obj;
    };
    else _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
    return _typeof(obj);
}
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("71e6a83c5f307acb"));
var _utils = require("de9c3f171412d069");
var _patterns = require("28faac23041cf786");
function _getRequireWildcardCache() {
    if (typeof WeakMap !== "function") return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
    };
    return cache;
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) return obj;
    if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") return {
        "default": obj
    };
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) return cache.get(obj);
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj)if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        if (desc && (desc.get || desc.set)) Object.defineProperty(newObj, key, desc);
        else newObj[key] = obj[key];
    }
    newObj["default"] = obj;
    if (cache) cache.set(obj, newObj);
    return newObj;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) symbols = symbols.filter(function(sym) {
            return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        if (i % 2) ownKeys(Object(source), true).forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
        else if (Object.getOwnPropertyDescriptors) Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        else ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) throw new TypeError("Super expression must either be null or a function");
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
}
function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _setPrototypeOf(o, p);
}
function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result;
        if (hasNativeReflectConstruct) {
            var NewTarget = _getPrototypeOf(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget);
        } else result = Super.apply(this, arguments);
        return _possibleConstructorReturn(this, result);
    };
}
function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) return call;
    return _assertThisInitialized(self);
}
function _assertThisInitialized(self) {
    if (self === void 0) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    return self;
}
function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Date.prototype.toString.call(Reflect.construct(Date, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}
function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
}
function _defineProperty(obj, key, value) {
    if (key in obj) Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
    });
    else obj[key] = value;
    return obj;
}
var SDK_URL = "https://player.vimeo.com/api/player.js";
var SDK_GLOBAL = "Vimeo";
var Vimeo = /*#__PURE__*/ function(_Component) {
    _inherits(Vimeo, _Component);
    var _super = _createSuper(Vimeo);
    function Vimeo() {
        var _this;
        _classCallCheck(this, Vimeo);
        for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++)args[_key] = arguments[_key];
        _this = _super.call.apply(_super, [
            this
        ].concat(args));
        _defineProperty(_assertThisInitialized(_this), "callPlayer", _utils.callPlayer);
        _defineProperty(_assertThisInitialized(_this), "duration", null);
        _defineProperty(_assertThisInitialized(_this), "currentTime", null);
        _defineProperty(_assertThisInitialized(_this), "secondsLoaded", null);
        _defineProperty(_assertThisInitialized(_this), "mute", function() {
            _this.setMuted(true);
        });
        _defineProperty(_assertThisInitialized(_this), "unmute", function() {
            _this.setMuted(false);
        });
        _defineProperty(_assertThisInitialized(_this), "ref", function(container) {
            _this.container = container;
        });
        return _this;
    }
    _createClass(Vimeo, [
        {
            key: "componentDidMount",
            value: function componentDidMount() {
                this.props.onMount && this.props.onMount(this);
            }
        },
        {
            key: "load",
            value: function load(url) {
                var _this2 = this;
                this.duration = null;
                (0, _utils.getSDK)(SDK_URL, SDK_GLOBAL).then(function(Vimeo) {
                    if (!_this2.container) return;
                    var _this2$props$config = _this2.props.config, playerOptions = _this2$props$config.playerOptions, title = _this2$props$config.title;
                    _this2.player = new Vimeo.Player(_this2.container, _objectSpread({
                        url: url,
                        autoplay: _this2.props.playing,
                        muted: _this2.props.muted,
                        loop: _this2.props.loop,
                        playsinline: _this2.props.playsinline,
                        controls: _this2.props.controls
                    }, playerOptions));
                    _this2.player.ready().then(function() {
                        var iframe = _this2.container.querySelector("iframe");
                        iframe.style.width = "100%";
                        iframe.style.height = "100%";
                        if (title) iframe.title = title;
                    })["catch"](_this2.props.onError);
                    _this2.player.on("loaded", function() {
                        _this2.props.onReady();
                        _this2.refreshDuration();
                    });
                    _this2.player.on("play", function() {
                        _this2.props.onPlay();
                        _this2.refreshDuration();
                    });
                    _this2.player.on("pause", _this2.props.onPause);
                    _this2.player.on("seeked", function(e) {
                        return _this2.props.onSeek(e.seconds);
                    });
                    _this2.player.on("ended", _this2.props.onEnded);
                    _this2.player.on("error", _this2.props.onError);
                    _this2.player.on("timeupdate", function(_ref) {
                        var seconds = _ref.seconds;
                        _this2.currentTime = seconds;
                    });
                    _this2.player.on("progress", function(_ref2) {
                        var seconds = _ref2.seconds;
                        _this2.secondsLoaded = seconds;
                    });
                    _this2.player.on("bufferstart", _this2.props.onBuffer);
                    _this2.player.on("bufferend", _this2.props.onBufferEnd);
                    _this2.player.on("playbackratechange", function(e) {
                        return _this2.props.onPlaybackRateChange(e.playbackRate);
                    });
                }, this.props.onError);
            }
        },
        {
            key: "refreshDuration",
            value: function refreshDuration() {
                var _this3 = this;
                this.player.getDuration().then(function(duration) {
                    _this3.duration = duration;
                });
            }
        },
        {
            key: "play",
            value: function play() {
                var promise = this.callPlayer("play");
                if (promise) promise["catch"](this.props.onError);
            }
        },
        {
            key: "pause",
            value: function pause() {
                this.callPlayer("pause");
            }
        },
        {
            key: "stop",
            value: function stop() {
                this.callPlayer("unload");
            }
        },
        {
            key: "seekTo",
            value: function seekTo(seconds) {
                this.callPlayer("setCurrentTime", seconds);
            }
        },
        {
            key: "setVolume",
            value: function setVolume(fraction) {
                this.callPlayer("setVolume", fraction);
            }
        },
        {
            key: "setMuted",
            value: function setMuted(muted) {
                this.callPlayer("setMuted", muted);
            }
        },
        {
            key: "setLoop",
            value: function setLoop(loop) {
                this.callPlayer("setLoop", loop);
            }
        },
        {
            key: "setPlaybackRate",
            value: function setPlaybackRate(rate) {
                this.callPlayer("setPlaybackRate", rate);
            }
        },
        {
            key: "getDuration",
            value: function getDuration() {
                return this.duration;
            }
        },
        {
            key: "getCurrentTime",
            value: function getCurrentTime() {
                return this.currentTime;
            }
        },
        {
            key: "getSecondsLoaded",
            value: function getSecondsLoaded() {
                return this.secondsLoaded;
            }
        },
        {
            key: "render",
            value: function render() {
                var display = this.props.display;
                var style = {
                    width: "100%",
                    height: "100%",
                    overflow: "hidden",
                    display: display
                };
                return /*#__PURE__*/ _react["default"].createElement("div", {
                    key: this.props.url,
                    ref: this.ref,
                    style: style
                });
            }
        }
    ]);
    return Vimeo;
}(_react.Component);
exports["default"] = Vimeo;
_defineProperty(Vimeo, "displayName", "Vimeo");
_defineProperty(Vimeo, "canPlay", _patterns.canPlay.vimeo);
_defineProperty(Vimeo, "forceLoad", true);

},{"71e6a83c5f307acb":"04RnP","de9c3f171412d069":"l0Nbp","28faac23041cf786":"eAFt4"}]},[], null, "parcelRequire2c0c")

//# sourceMappingURL=Vimeo.ce031c43.js.map
