//@include"json2.js";
log("ExtendScript Started");
  
registerProjChange()  
registerSeqChange();
registerActiveSeqChange();

var lastProj = app.project.documentID
var lastSeqCount = app.project.sequences.length
var externalObjectName = "PlugPlugExternalObject"; 
var mylib = new ExternalObject( "lib:" + externalObjectName );
var eventObj = new CSXSEvent();

function loopVideo(sequence){
  try {
    var pathArray = new Array();
    if (sequence) {
      var seqIndex = matchNode(sequence);
      var seqName = app.project.sequences[seqIndex];
      pathArray = checkVideo(seqName);
      return JSON.stringify(pathArray);
    } else {
      var seqName = app.project.activeSequence;
      pathArray = checkVideo(seqName);
      return JSON.stringify(pathArray);
    }
  } catch (e) {
    log(e);
  }
}

function loopAudio(sequence){
  try {
    var pathArray = new Array();
    if (sequence) {
      var seqIndex = matchNode(sequence);
      var seqName = app.project.sequences[seqIndex];
      pathArray = checkAudio(seqName);
      return JSON.stringify(pathArray);
    } else {
      var seqName = app.project.activeSequence;
      pathArray = checkAudio(seqName);
      return JSON.stringify(pathArray);
    }
  } catch (e) {
    log(e);
  }
}

function checkVideo(seqName){
  try {
    var pathArray = new Array();
    if (!seqName) {
      return pathArray;
    } else {
      for (var i = 0; i < seqName.videoTracks.length; i++) {
        for (var j = 0; j < seqName.videoTracks[i].clips.length; j++) {
          if (!seqName.videoTracks[i].clips[j].projectItem || !seqName.videoTracks[i].clips[j] || (seqName.videoTracks[i].clips[j].isAdjustmentLayer() === true)) {
            continue;
          } else if (seqName.videoTracks[i].clips[j].projectItem.isSequence() == true && seqName.videoTracks[i].clips[j].projectItem.isMergedClip() == false) {
            var multiClipName = seqName.videoTracks[i].clips[j].projectItem.nodeId;
            var multiSequenceIndex = matchNode(multiClipName);
            var multiSequence = app.project.sequences[multiSequenceIndex]
            var multiVideo = checkVideo(multiSequence);
            pathArray = pathArray.concat(multiVideo)
            continue;
          } else {
            var videoClipInfo = {
              name: seqName.videoTracks[i].clips[j].projectItem.name,
              nodeId: seqName.videoTracks[i].clips[j].projectItem.nodeId,
              origPath: seqName.videoTracks[i].clips[j].projectItem.getMediaPath(),
              hasProxy: seqName.videoTracks[i].clips[j].projectItem.hasProxy(),
              proxyPath: seqName.videoTracks[i].clips[j].projectItem.getProxyPath(),
              mediaType: seqName.videoTracks[i].clips[j].mediaType,
              sourceLength: parseXML(seqName.videoTracks[i].clips[j].projectItem),
              startOffset: (seqName.videoTracks[i].clips[j].inPoint.ticks),
              endOffset: (seqName.videoTracks[i].clips[j].outPoint.ticks)
            }; 
            pathArray.push(videoClipInfo);
          }
        }
      }
      return pathArray;
    }
  } catch (e) {
    log(e);
  }
}

function checkAudio(seqName){
  try {
    var pathArray = new Array();
    if (!seqName) {
      return pathArray;
    } else {
      for (var i = 0; i < seqName.audioTracks.length; i++) {
        for (var j = 0; j < seqName.audioTracks[i].clips.length; j++) {
          if (!seqName.audioTracks[i].clips[j].projectItem || !seqName.audioTracks[i].clips[j] || (seqName.audioTracks[i].clips[j].isAdjustmentLayer() === true)) {
            continue;
          } else if (seqName.audioTracks[i].clips[j].projectItem.isSequence() == true && seqName.audioTracks[i].clips[j].projectItem.isMergedClip() == false) {
            var multiClipName = seqName.audioTracks[i].clips[j].projectItem.nodeId;
            var multiSequenceIndex = matchNode(multiClipName);
            var multiSequence = app.project.sequences[multiSequenceIndex]
            var multiAudio = checkAudio(multiSequence);
            pathArray = pathArray.concat(multiAudio)
            continue;
          } else {
            var audioClipInfo = {
              name: seqName.audioTracks[i].clips[j].projectItem.name,
              nodeId: seqName.audioTracks[i].clips[j].projectItem.nodeId,
              origPath: seqName.audioTracks[i].clips[j].projectItem.getMediaPath(),
              hasProxy: seqName.audioTracks[i].clips[j].projectItem.hasProxy(),
              proxyPath: seqName.audioTracks[i].clips[j].projectItem.getProxyPath(),
              mediaType: seqName.audioTracks[i].clips[j].mediaType,
              sourceLength: parseXML(seqName.audioTracks[i].clips[j].projectItem),
              startOffset: (seqName.audioTracks[i].clips[j].inPoint.ticks),
              endOffset: (seqName.audioTracks[i].clips[j].outPoint.ticks)
          };
          pathArray.push(audioClipInfo);
          }
        }
      }
      return pathArray; 
    }
  } catch (e) {
    log(e);
  }
}

function matchNode(clipNode){
  try {
    for (var i = 0; i < app.project.sequences.length; i++) {
      if (app.project.sequences[i].hasOwnProperty('projectItem') && app.project.sequences[i].projectItem !== null) {
        if (app.project.sequences[i].projectItem.nodeId == clipNode) {
          var foundSeq = [i];
          return foundSeq;
        } else {
          continue;
        }
      } else {
        continue;
      }
    }
  } catch(e) {
    log(e);
  }
}

function binNode(node, nodeId) {
  if (node.nodeId === nodeId) {
      return node;
  }

  if (node.children && node.children.length > 0 && (node.type === 2 || node.type === 3)) {
      for (var i = 0; i < node.children.length; i++) {
          if (node.children[i].nodeId === nodeId) {
              return node.children[i];
          } else {
              var result = binNode(node.children[i], nodeId);
              if (result !== null) {
                  return result;
              }
          }
      }
  }

  return null;
}

function checkCollab(){
  return app.properties.getProperty("BE.Prefs.ProjectLocking.EnableProjectLocking");
}

function collabOn(){
  app.properties.setProperty("BE.Prefs.ProjectLocking.EnableProjectLocking", "true", true, true);
}

function collabOff(){
  app.properties.setProperty("BE.Prefs.ProjectLocking.EnableProjectLocking", "false", true, true);
}

function checkWaveform(){
  return app.properties.getProperty("BE.Prefs.Audio.AutoPeakGeneration");
}

function waveformOff(){
  app.properties.setProperty("BE.Prefs.Audio.AutoPeakGeneration", "false", true, true);
}

function waveformOn(){
  app.properties.setProperty("BE.Prefs.Audio.AutoPeakGeneration", "true", true, true);
}

function checkMxf(){
  app.enableQE()
  return qe.getDebugDatabaseEntry("ImporterMXF.SpeculativeIndexingModeThreshold");
}

function mxfOn(){
  qe.setDebugDatabaseEntry("ImporterMXF.SpeculativeIndexingModeThreshold", "0");
}

function mxfOff(){
  qe.setDebugDatabaseEntry("ImporterMXF.SpeculativeIndexingModeThreshold", "2");
}

function getBins(id) {
  var binList = listBins(id);
  return JSON.stringify(binList);
}

function listBins(id) {
  try {
    var item = binNode(app.project.rootItem, id) === null ? app.project.rootItem : binNode(app.project.rootItem, id);
    var binArray = new Array();

    for (var i = 0; i < item.children.length; i++) {
      if (item.children[i].type === 2) {
        var childBins = new Array();
        var nestedBins = new Array();

        if (item.children[i].children.length > 0) {
          nestedBins = loopBins(item.children[i]);

              for (var j = 0; j < item.children[i].children.length; j++) {
                childBins.push ({
                  parentId: item.children[i].nodeId,
                  parentName: item.children[i].name,
                  project: app.project.documentID,
                  name: item.children[i].children[j].name,
                  nodeId: item.children[i].children[j].id,
                  type: "bin"
                })
              }
          }

        var binObj = {
          parentId: item.nodeId,
          parentName: item.name,
          project: app.project.documentID, 
          name: item.children[i].name,
          nodeId: item.children[i].nodeId,
          childArray: childBins,
          treeFlat: nestedBins,
          type: "bin"
        };

        binArray.push(binObj);
      } else {
        continue;
      }
    }
    return binArray;
  } catch (e) {
    log(e);
  }
}

function loopBins(item) {
  try {
    var binArray = new Array();
    var nestedBins = new Array();
    for (var i = 0; i < item.children.length; i++) {
      if (item.children[i] && item.children[i].type === 2) {
        binArray.push(item.children[i].nodeId);

        if (item.children[i].children.length > 0) {
          var nestedBins = loopBins(item.children[i]);
          binArray = binArray.concat(nestedBins);
        }
      }
    }
    return binArray;
  } catch (e) {
    log(e);
    return [];
  }
}

function getBinContents(id) {
  try {
    var inputBin = binNode(app.project.rootItem, id);
    if (inputBin === null) {
      return []
    }
    var contentArray = new Array();
    for (var i = 0; i < inputBin.children.length; i++) {
      if (inputBin.children[i].type === 1 && inputBin.children[i].isSequence() === false) {
        var contentObj = {
          name: inputBin.children[i].name,
          nodeId: inputBin.children[i].nodeId,
          origPath: inputBin.children[i].getMediaPath(),
          hasProxy: inputBin.children[i].hasProxy(),
          proxyPath: inputBin.children[i].getProxyPath(),
          mediaType: inputBin.children[i].mediaType,
          type: "clip"
        }
        contentArray.push(contentObj);
      } else if (inputBin.children[i].isSequence() === true) {
        var contentObj = {
          name: inputBin.children[i].name,
          nodeId: inputBin.children[i].nodeId,
          project: app.project.documentID,
          type: "sequence"
        }
        contentArray.push(contentObj);
      } else {
        continue;
      }
    }
    return JSON.stringify(contentArray);
  } catch(e) {
    log(e)
  }
}

function listSequences(){
  try {
    var seqArray = new Array();
    for (var i = 0; i < app.project.sequences.length; i++) {
      if (app.project.sequences[i].hasOwnProperty('projectItem') && app.project.sequences[i].projectItem !== null) {
        if (app.project.sequences[i].projectItem.isMulticamClip() == false && app.project.sequences[i].projectItem.isMergedClip() == false) {
          var seqIndex = {
            name: app.project.sequences[i].name,
            nodeId: app.project.sequences[i].projectItem.nodeId,
            project: app.project.documentID
          };
          if (app.project.activeSequence && (app.project.sequences[i].projectItem.nodeId === app.project.activeSequence.projectItem.nodeId)) {
            seqIndex.activeSequence = true;
          } else {
            seqIndex.activeSequence = false;
          };
          seqArray.push(seqIndex);
        } else {
          continue;
        } 
      } else {
        continue;
      }
    }
    return JSON.stringify(seqArray);
  } catch (e) {
    log(e);
  }
}

function listProject(){
  if (app.hasOwnProperty("encoder")) {
    var projectObj = {
      name: app.project.name,
      nodeId: app.project.rootItem.nodeId,
      project: app.project.documentID
    }
    return JSON.stringify(projectObj);
  } else {
    var projectObj = {
      name: app.project.file == null ? "Unsaved" : File.decode(app.project.file.name),
    }
    return JSON.stringify(projectObj);
  }
}

function parseXML(projectItem){
  var metadataURI	= "http://ns.adobe.com/premierePrivateProjectMetaData/1.0/";
  var mediaType = projectItem.mediaType;
  if (mediaType === "Video") {
    var mediaDuration = "Column.Intrinsic.VideoOutPoint"
  } else if (mediaType === "Audio") {
    var mediaDuration = "Column.Intrinsic.AudioOutPoint"
  } else {
    var mediaDuration = "Column.Intrinsic.VideoOutPoint"
  }
  try {
    if (ExternalObject.AdobeXMPScript === undefined) {
      ExternalObject.AdobeXMPScript = new ExternalObject('lib:AdobeXMPScript');
      var projectMetadata = projectItem.getProjectMetadata();
      var xmp = new XMPMeta(projectMetadata);
      var duration = xmp.getQualifier(metadataURI, mediaDuration, metadataURI, "max")
      return duration.value;
    } else if (ExternalObject.AdobeXMPScript !== undefined) {
      var projectMetadata = projectItem.getProjectMetadata();
      var xmp = new XMPMeta(projectMetadata);
      var duration = xmp.getQualifier(metadataURI, mediaDuration, metadataURI, "max")
      return duration.value;
    } else {
      return 0;
    }
  } catch (e) {
    log(e);
  }
}

function loadSource(clipNode, seqNode, mediaType){
  try {
    var seqIndex = matchNode(seqNode);
    var seqName = app.project.sequences[seqIndex];
    if (mediaType === "Video") {
      for (var i = 0; i < seqName.videoTracks.length; i++) {
        for (var j = 0; j < seqName.videoTracks[i].clips.length; j++) {
          if (seqName.videoTracks[i].clips[j].projectItem.nodeId === clipNode) {
            var targetItem = seqName.videoTracks[i].clips[j].projectItem;
            var isSuccess = app.sourceMonitor.openProjectItem(targetItem);
            if (isSuccess === 1) {
              var filePath = encodeURIComponent(targetItem.getMediaPath());
              app.sourceMonitor.openFilePath(filePath);
            }
          } else if (seqName.videoTracks[i].clips[j].projectItem.isSequence() === true) {
            seqNode = seqName.videoTracks[i].clips[j].projectItem.nodeId;
            loadSource(clipNode, seqNode, mediaType);
          }
        }
      }
    } else if (mediaType === "Audio") {
      for (var i = 0; i < seqName.audioTracks.length; i++) {
        for (var j = 0; j < seqName.audioTracks[i].clips.length; j++) {
          if (seqName.audioTracks[i].clips[j].projectItem.nodeId === clipNode) {
            var targetItem = seqName.audioTracks[i].clips[j].projectItem;
            var isSuccess = app.sourceMonitor.openProjectItem(targetItem);
            if (isSuccess === 1) {
              var filePath = encodeURIComponent(targetItem.getMediaPath());
              app.sourceMonitor.openFilePath(filePath);
            }
          } else if (seqName.audioTracks[i].clips[j].projectItem.isSequence() === true) {
            seqNode = seqName.audioTracks[i].clips[j].projectItem.nodeId;
            loadSource(clipNode, seqNode, mediaType);
          } 
        }
      }
    }
  } catch (e) {
    log(e)
  }
}

function loadAeElement(id){
  try {
    app.project.itemByID(id).openInViewer()
  } catch (e) {
    log(e)
  }
}

function dispatchDeleteEvent() {
  eventObj.type="seqDelete"; 
  eventObj.data="Sequence(s) deleted"; 
  eventObj.dispatch()
}

function dispatchAddEvent() {
  eventObj.type="seqAdd"; 
  eventObj.data="Sequence(s) added"; 
  eventObj.dispatch()
}

function dispatchProjChange() {
  eventObj.type="projChange"; 
  eventObj.data="Project changed"; 
  eventObj.dispatch()
}

function dispatchSeqChange() {
  eventObj.type="seqChange"; 
  eventObj.data="Active sequence changed"; 
  eventObj.dispatch()
}

function dispatchClipEvent() {
  eventObj.type="clipChange"; 
  eventObj.data=app.project.activeSequence.projectItem.nodeId;
  eventObj.dispatch()
}

function checkProjChange() {
  if (app.project.sequences.length < lastSeqCount) {
    dispatchDeleteEvent();
    lastSeqCount = app.project.sequences.length;
  } else if (app.project.sequences.length > lastSeqCount) {
    dispatchAddEvent();
    lastSeqCount = app.project.sequences.length;
  }
}

function checkSeqChange() {
  if (app.project.documentID != lastProj) {
    dispatchProjChange();
    lastProj = app.project.documentID;
  }
  dispatchSeqChange();
}

function registerProjChange() {
  app.bind('onProjectChanged', checkProjChange);
}

function registerActiveSeqChange() {
  app.bind('onSequenceActivated', checkSeqChange);
}

function registerSeqChange() {
  app.bind('onActiveSequenceTrackItemRemoved',	dispatchClipEvent);
  app.bind('onActiveSequenceTrackItemAdded',		dispatchClipEvent);
}

function getFolders(id) {
  var folderList = listFolders(id);
  return JSON.stringify(folderList);
}

function listFolders(id) {
  try {
    var item;

    id = parseInt(id, 10);
  
      if (id && typeof id === "number" && id > 0) {
        item = app.project.itemByID(id);
      } else {
        item = app.project;
        var isRoot = true;
      }
  
      if (!item) {
        return []; 
      }
      var folderArray = new Array();
  
      for (var i = 1; i <= item.items.length; i++) {
        if (isRoot) {
          if (item.items[i] && (item.items[i] instanceof FolderItem) && (item.items[i].parentFolder.name === "Root")) {
            var childFolders = new Array();
            var nestedFolders = new Array();

            if (item.items[i].numItems > 0) {
              nestedFolders = loopFolders(item.items[i]);
    
              for (var j = 1; j <= item.items[i].items.length; j++) {
                childFolders.push ({
                  parentId: item.id == undefined ? 0 : item.id,
                  parentName: item.name == undefined ? JSON.parse(listProject()).name : item.name,
                  name: item.items[i].items[j].name,
                  nodeId: item.items[i].items[j].id,
                  type: "folder"
                })
              }
          }
    
          var folderObj = {
            parentId: item.id == undefined ? 0 : item.id,
            parentName: item.name == undefined ? JSON.parse(listProject()).name : item.name,
            name: item.items[i].name,
            nodeId: item.items[i].id,
            childArray: childFolders,
            treeFlat: nestedFolders,
            type: "folder"
          };
          folderArray.push(folderObj);
        } else {
          continue;
        }
        } else {
          if (item.items[i] && (item.items[i] instanceof FolderItem)) {
            var childFolders = new Array();
            var nestedFolders = new Array();
    
            if (item.items[i].numItems > 0) {
              nestedFolders = loopFolders(item.items[i]);
    
              for (var j = 1; j <= item.items[i].items.length; j++) {
                childFolders.push ({
                  parentId: item.items[i].items[j].parentFolder.id,
                  parentName: item.items[i].items[j].parentFolder.name,
                  name: item.items[i].items[j].name,
                  nodeId: item.items[i].items[j].id,
                  type: "folder"
                })
              }
          }
          var folderObj = {
            parentId: item.items[i].parentFolder.id,
            parentName: item.items[i].parentFolder.name,
            name: item.items[i].name,
            nodeId: item.items[i].id,
            childArray: childFolders,
            treeFlat: nestedFolders,
            type: "folder"
          };
          folderArray.push(folderObj);
        } else {
          continue;
        }
      }
    }
    return folderArray;
  } catch(e) {
    log(e);
    return [];
  }
}

function loopFolders(item) {
  try {
    var folderArray = [];
    for (var i = 1; i <= item.items.length; i++) {
      if (item.items[i] && (item.items[i] instanceof FolderItem)) {
        folderArray.push(item.items[i].id);

        if (item.items[i].numItems > 0) {
          var nestedFolders = loopFolders(item.items[i]);
          folderArray = folderArray.concat(nestedFolders);
        }
      }
    }
    return folderArray;
  } catch(e) {
    log(e);
    return [];
  }
}

function getFolderContents(id) {
  try {
    if (id && typeof id === "number" && id > 0) {
      var inputFolder = app.project.itemByID(id);
      var contentArray = new Array();
      for (var i = 1; i <= inputFolder.items.length; i++) {
        if ((((inputFolder.items[i] instanceof FootageItem === true) && (inputFolder.items[i].mainSource instanceof SolidSource === false)))) {
          var contentObj = {
            name: inputFolder.items[i].name,
            nodeId: inputFolder.items[i].id,
            hasProxy: inputFolder.items[i].proxySource != null ? true : false,
            origPath: inputFolder.items[i].mainSource != null ? inputFolder.items[i].mainSource.file.fsName : "",
            proxyPath: inputFolder.items[i].proxySource != null ? inputFolder.items[i].proxySource.file.fsName : "",
            mediaType: inputFolder.items[i].mainSource.isStill === true ? "Still" : "Video",
            type: "layer"
          }
          contentArray.push(contentObj);
        } else if (inputFolder.items[i] instanceof CompItem === true) {
          var contentObj = {
            name: inputFolder.items[i].name,
            nodeId: inputFolder.items[i].id,
            type: "comp"
          }
          contentArray.push(contentObj);
        } else {
          continue;
        }
      }
      return JSON.stringify(contentArray);
    } else {
      return []
    }
  } catch(e) {
    log(e)
  }
}

function listCompositions(){
  try {
    var compArray = new Array();
    for (var i = 1; (i <= app.project.items.length); i++) {
      if (app.project.items[i] && (app.project.items[i] instanceof CompItem === true) && app.project.activeItem) {
        var compIndex = {
          name: app.project.items[i].name,
          nodeId: app.project.items[i].id,
          activeComp: app.project.items[i].id === app.project.activeItem.id ? true : false
        };
        compArray.push(compIndex);
      } else if (app.project.items[i] && (app.project.items[i] instanceof CompItem === true) && !app.project.activeItem) {
        var compIndex = {
          name: app.project.items[i].name,
          nodeId: app.project.items[i].id,
          activeComp: false
        };
        compArray.push(compIndex);
      } else {
        continue;
      }
    }
    return JSON.stringify(compArray);
  } catch (e) {
    log(e);
  }
}

function getLayers(id) {
  var layerList = listLayers(id);
  return JSON.stringify(layerList);
}

function listLayers(id){
  if (id === 0 || typeof id != "number") {
    return []
  }
  try {
    var inputComp = app.project.itemByID(id);
    if (inputComp.numLayers === 0) {
      return []
    }
    var footageArray = new Array();
    for (var i = 1; i <= inputComp.numLayers; i++) {
      if ((((inputComp.layers[i].source instanceof FootageItem === true) && (inputComp.layers[i].source.mainSource instanceof SolidSource === false)))) {
        var footageIndex = {
          name: inputComp.layers[i].name,
          nodeId: inputComp.layers[i].source.id,
          hasProxy: inputComp.layers[i].source.proxySource != null ? true : false,
          origPath: inputComp.layers[i].source.mainSource != null ? inputComp.layers[i].source.mainSource.file.fsName : "",
          proxyPath: inputComp.layers[i].source.proxySource != null ? inputComp.layers[i].source.proxySource.file.fsName : "",
          mediaType: inputComp.layers[i].source.mainSource.isStill === true ? "Still" : "Video"
        }
        footageArray.push(footageIndex);
      } else if ((inputComp.layers[i].source instanceof CompItem === true)){
        var nestedArray = listLayers(inputComp.layers[i].source.id);
        footageArray = footageArray.concat(nestedArray);
      }
    }
    return footageArray;
  } catch (e) {
    log (e)
  }
}

function log(input) {
  var now = new Date();
  var logMessage;

  if (input && (typeof input.line !== 'undefined' || typeof input.message !== 'undefined')) {
    var errorMessage = input.message || 'Message not available';
    var errorLine = typeof input.line !== 'undefined' ? input.line : 'Line info not available';
    logMessage = now.toTimeString() + " - Error Message: " + errorMessage + "; Error Line: " + errorLine;
  } else {
    logMessage = now.toTimeString() + " - Log: " + JSON.stringify(input);
  }

  $.writeln(logMessage);

  var logFolder = new Folder("~/.lucidPanel");
  if (!logFolder.exists) {
    logFolder.create();
  }

  var logFilePath = logFolder.fsName + "/jsx.log";
  var logFile = new File(logFilePath);

  if (logFile.open("e")) {
    logFile.seek(0, 2);

    if (logFile.tell() > 10485760) {
      logFile.close();

      var rotatedLogName = "jsx-" + now.getFullYear() + '-' + (now.getMonth() + 1) + '-' + now.getDate() + '-' + now.getHours() + '-' + now.getMinutes() + '-' + now.getSeconds() + ".log";
      var rotatedLogFilePath = logFolder.fsName + "/" + rotatedLogName;

      logFile.rename(rotatedLogFilePath);
      logFile = new File(logFilePath); 
      logFile.open("a");
    } else {
      logFile.close();
      logFile.open("a");
    }
  }

  logFile.writeln(logMessage);
  logFile.close();
}